<?php

	require("./pre.inc.php");
		
	if (!$user->rights->compta->depense->lire)
	    accessforbidden();

	$langs->load("bills");

    include_once(DOL_DOCUMENT_ROOT.'/compta/compta.class.php');
	include_once(DOL_DOCUMENT_ROOT.'/compta/bank/account.class.php');
	
	$vline=isset($_GET["vline"])?$_GET["vline"]:$_POST["vline"];

	$type_piece=isset($_GET["type_piece"])?$_GET["type_piece"]:$_POST["type_piece"];
	$libelle_type_piece = _get_libelle_type_piece($db, $type_piece);
	
	$action_encours=isset($_GET["action_encours"])?$_GET["action_encours"]:$_POST["action_encours"];
	$action_demandee=isset($_GET["action_demandee"])?$_GET["action_demandee"]:$_POST["action_demandee"];
	
	if ($action_demandee == 'nouvelle_piece' || $action_demandee == 'del_ligne' || $action_demandee == 'del_ligne_reglement') $action_encours = 'saisir_piece';
 
	$ligne_del=$_POST["ligne_del"];
	$ligne_del_reglement=$_POST["ligne_del_reglement"];
	$page=isset($_GET["page"])?$_GET["page"]:$_POST["page"];
	$confirm_piece=$_POST["confirm_piece"];
	$nb_lignes=$_POST["nb_lignes"];
	if ($nb_lignes == '') $nb_lignes = 0;
	$nb_lignes_reglement=$_POST["nb_lignes_reglement"];
	if ($nb_lignes_reglement == '') $nb_lignes_reglement = 0;
	
	$date_piece = strftime( "%Y-%m-%d", mktime(0, 0, 0, substr($_POST["datep"],3,2), substr($_POST["datep"],0,2), substr($_POST["datep"],6)));
    $nature=$_POST["nature"];
    $libelle=$_POST["libelle"];
    $montant_ht=$_POST["montant_ht"];
    $montant_tva=$_POST["montant_tva"];
    $montant_ttc=$_POST["montant_ttc"];
    $montant_reglement=$_POST["montant_reglement"];
    $tiers=$_POST["tiers"];
	$mrg=$_POST["mrg"];
	$treso=$_POST["treso"];

	$nb_erreurs = 0;
	
	if ($action_demandee == 'annule_piece') {
		$nb_lignes = 0;
		$nb_lignes_reglement = 0;
		$action_encours = '';
	}
	elseif ($action_demandee == 'generer_lignes')	
	{ 
			$nb_lignes = _genere_lignes($db, $tiers, $nature, $libelle, $montant_ht, $montant_tva, $montant_ttc, $tiers, $mrg, $treso, $montant_reglement);
	}
 	elseif ($action_demandee == 'generer_lignes_reglement')	
	{ 
			$nb_lignes_reglement = _genere_lignes_reglement($db, $tiers, $nature, $libelle, $montant_ht, $montant_tva, $montant_ttc, $tiers, $mrg, $treso, $montant_reglement);
	}
	if ($vline)
    {
      $viewline = $vline;
    }
	else
    {
      $viewline = 24;
    }
	//validation d'une pice
	if ($_POST['action_demandee'] == 'confirm_valid' && $confirm_piece == 'yes' && $user->rights->facture->valider)
	{
		$nb_erreurs=sizeOf($erreurs=_controle_piece($db));
		if ($nb_erreurs == 0) 
		{
			$id_piece = _valid_piece($db);
			if ($id_piece) $id_piece_reglement = _valid_piece_reglement($db);
			if ($id_piece && $id_piece_reglement)
			{
				if ($montant_ttc == $montant_reglement)
				{
					$lettrage = new Lettrage($db);
					$code_lettrage = $lettrage->getNewLettrage();
				}
				else $code_lettrage = 'P';
				$piece = new Piece($db, $id_piece);
				$piece->setLettrage($code_lettrage);
				$piece = new Piece($db, $id_piece_reglement);
				$piece->setLettrage($code_lettrage);
			}
			$nb_lignes = 0;
			$nb_lignes_reglement = 0;
			$action_encours = '';
			//Header("Location: deprec.php?type_piece=".$type_piece);
		}
			
	}

	// Affichage header dolibarr
	llxHeader();
	$html=new Form($db);

	//controle de la piece
	if ($action_demandee == 'controle_piece') {
		$nb_erreurs=sizeOf($erreurs=_controle_piece($db));
		if ($nb_erreurs == 0) {
			$html->form_confirm("javascript:document.getElementById('confirm_piece').value=document.forms[3].elements['confirm'].value;document.getElementById('action_demandee').value='confirm_valid';document.form_saisie.submit();",'Validation d\'une '.$libelle_type_piece,'Etes-vous sr de vouloir valider cette '.$libelle_type_piece.' ?','confirm_piece');
			print '<br />';
		}
	}

	$lignes_affichees = isset($_GET["lignes_affichees"])?$_GET["lignes_affichees"]:$_POST["lignes_affichees"] || ($action_demandee == 'nouvelle_ligne' || $action_demandee == 'del_ligne' || $action_demandee == 'generer_lignes');
	$lignes_reglement_affichees = isset($_GET["lignes_reglement_affichees"])?$_GET["lignes_reglement_affichees"]:$_POST["lignes_reglement_affichees"] || ($action_demandee == 'nouvelle_ligne_reglement' || $action_demandee == 'del_ligne_reglement' || $action_demandee == 'generer_lignes_reglement');
    
 /*
     * Affiche tableau des oprations comptables
     *
     */

    print '<table class="notopnoleftnoright" width="100%">';
    // Formulaire de saisie d'une opration 
    if ($user->rights->banque->modifier && $action_encours == 'saisir_piece') 
    {
		if (!$_POST["datep"]) {
			$datep = date("d/m/y");
		}
		else {
			$datep = $_POST["datep"];
		}

		print '<form name="form_saisie" method="post" action="deprec.php">';
        print '<input id="action_demandee" type="hidden" name="action_demandee" value="">';
        print '<input id="action_encours" type="hidden" name="action_encours" value="saisir_piece">';
        print '<input type="hidden" name="lignes_affichees" value="'.$lignes_affichees.'">';
        print '<input type="hidden" name="lignes_reglement_affichees" value="'.$lignes_affichees.'">';
        print '<input id="confirm_piece" type="hidden" name="confirm_piece" value="no">';
        print '<input type="hidden" name="vline" value="' . $vline . '">';
        print '<input type="hidden" id="ligne_del" name="ligne_del" value="' . 0 . '">';
        print '<input type="hidden" id="ligne_del_reglement" name="ligne_del" value="' . 0 . '">';
        print '<input type="hidden" id="page" name="page" value="' . $page . '">';
        print '<input type="hidden" id="journal" name="journal" value="' . $journal . '">';
        print '<input type="hidden" name="type_piece" value="' . $type_piece . '">';
        
		print '<tr>';
        print '<td align="left" colspan="8">';
		print_fiche_titre($langs->trans("Saisie d'une ".strtolower($libelle_type_piece)));
		print '</td>';
        print '</tr>';

		// Erreurs de la saisie
		if ($nb_erreurs > 0) 
		{
			print '<tr><td colspan="8">';
			$err = 0;
			while ($err < $nb_erreurs) {
				print "<font color='red'>".$erreurs[$err]."</font><br>";
				$err++;
			}
			print '</td></tr>';
		}        
		print '<tr>';
        print '<td align="left" colspan="8">';
		print '<table class="notopnoleftnoright" width="100%">';
    	print '<tr class="liste_titre">';
        print '<td>'.$langs->trans("Date").'</td>';
		print '<td>'.$langs->trans("Nature").'</td>';
		print '<td>'.$langs->trans("Libell").'</td>';
		print '<td colspan="2">'.$langs->trans("Tiers").'</td>';
        print '</tr>';
		print '<tr '.$bc[true].'>';
        print '<td>';
        print '<input name="datep" class="flat" type="text" size="7" maxlength="10" value="'.$datep.'"></td>';
        print '<td><select class="flat" name="nature">'._charge_natures($db).'</select></td>';
		print '<td><input name="libelle" class="flat" type="text" size="30" value="'.$_POST["libelle"].'"></td>';
        print '<td colspan="2"><select class="flat" name="tiers">'._charge_tiers($db).'</select></td>';
		print '</tr>';
		print '<tr class="liste_titre">';
        print '<td></td><td>'.$langs->trans("Montant HT").'</td><td>'.$langs->trans("Montant TVA").'</td><td colspan="2">'.$langs->trans("Montant TTC").'</td>';
        print '</tr>';
		print '<tr '.$bc[true].'>';
        print '<td></td>';
        print '<td><input name="montant_ht" class="flat" type="text" size="6" value="'.$_POST["montant_ht"].'"></td>';
        print '<td><input name="montant_tva" class="flat" type="text" size="6" value="'.$_POST["montant_tva"].'"></td>';
        print '<td><input name="montant_ttc" class="flat" type="text" size="6" value="'.$_POST["montant_ttc"].'"></td>';
        print "<td align=\"center\"><a href=\"#\" onclick=\"document.getElementById('action_demandee').value='generer_lignes';document.form_saisie.submit();\">";
		if ($lignes_affichees) print "Gnrer lignes";
		else print "Afficher lignes";
		print "</a></td>\n";
		print '</tr>';
        
		// Saisie des lignes
		if ($lignes_affichees)	
		{
			print '<tr><td colspan="5">';
			print '<table class="notopnoleftnoright" width="100%">';
			print '<tr '.$bc[false].'>';
			print '<td>'.$langs->trans("Ligne").'</td><td>'.$langs->trans("Libell ligne").'</td><td>'.$langs->trans("Compte").'</td><td>'.$langs->trans("Sens").'</td><td colspan="2">'.$langs->trans("Montant").'</td>';
	        print '</tr>';
		
			$i = 0;
			$num_ligne = 0;
			$sens_prec = '';
			while ($i < $nb_lignes) { 
				$i++;
				if ($ligne_del != $i) {
					$num_ligne++;
					$sens_prec = _affiche_ligne($db, $i, $sens_prec, $num_ligne);
				}
			}
			
			$nb_lignes = $num_ligne;
			if ($action_demandee == 'nouvelle_ligne') {
				$num_ligne++;
				$sens_prec = _affiche_ligne($db, 0, $sens_prec, $num_ligne);
				$nb_lignes++;
			}
			print '<script language="javascript">document.forms["form_saisie"].elements["libelle_ligne_'.$num_ligne.'"].focus();</script>';
			print '<tr><td align="right" colspan="5"><input type="submit" name="add_line" class="button" value="'.$langs->trans("Ajouter une ligne").'" onclick="document.getElementById(\'action_demandee\').value=\'nouvelle_ligne\';">';
			print '</td></tr>';
			print '</table></td></tr>';
		
		}
		else print '<script language="javascript">document.forms["form_saisie"].elements["datep"].focus();</script>';
		print '<tr class="liste_titre">';
        print '<td></td>';
        print '<td>'.$langs->trans("Montant Regl").'</td><td>'.$langs->trans("Mode de rglement").'</td><td colspan="2">'.$langs->trans("Compte de trsorerie").'</td>';
       print '</tr>';
		print '<tr '.$bc[true].'>';
		print '<td></td>';
        print '<td><input name="montant_reglement" class="flat" type="text" size="6" value="'.$_POST["montant_reglement"].'"></td>';
        print '<td><select class="flat" name="mrg">'._charge_mrg($db).'</select></td>';
		print '<td><select class="flat" name="treso">'._charge_tresos($db).'</select></td>';
		print "<td align=\"center\"><a href=\"#\" onclick=\"document.getElementById('action_demandee').value='generer_lignes_reglement';document.form_saisie.submit();\">";
		if ($lignes_reglement_affichees) print "Gnrer lignes";
		else print "Afficher lignes";
		print "</a></td>\n";
		print '</tr>';
        
		// Saisie des lignes
		if ($lignes_reglement_affichees)	
		{
			print '<tr><td colspan="5">';
			print '<table class="notopnoleftnoright" width="100%">';
			print '<tr '.$bc[false].'>';
			print '<td>'.$langs->trans("Ligne").'</td><td>'.$langs->trans("Libell ligne").'</td><td>'.$langs->trans("Compte").'</td><td>'.$langs->trans("Sens").'</td><td colspan="2">'.$langs->trans("Montant").'</td>';
	        print '</tr>';
			$i = 0;
			$num_ligne = 0;
			$sens_prec = '';
			while ($i < $nb_lignes_reglement) { 
				$i++;
				if ($ligne_del_reglement != $i) {
					$num_ligne++;
					$sens_prec = _affiche_ligne_reglement($db, $i, $sens_prec, $num_ligne);
				}
			}
			
			$nb_lignes_reglement = $num_ligne;
			if ($action_demandee == 'nouvelle_ligne_reglement') {
				$num_ligne++;
				$sens_prec = _affiche_ligne_reglement($db, 0, $sens_prec, $num_ligne);
				$nb_lignes_reglement++;
			}
			print '<script language="javascript">document.forms["form_saisie"].elements["libelle_ligne_reglement_'.$num_ligne.'"].focus();</script>';
			print '<tr><td align="right" colspan="5"><input type="submit" name="add_line" class="button" value="'.$langs->trans("Ajouter une ligne").'" onclick="document.getElementById(\'action_demandee\').value=\'nouvelle_ligne_reglement\';">';
			print '</td></tr>';
			print '</table></td></tr>';
		
		}
		else print '<script language="javascript">document.forms["form_saisie"].elements["datep"].focus();</script>';
			
	    if (($action_demandee != 'controle_piece') || $nb_erreurs != 0) 
		{
			print '<tr '.$bc[false].'>';
			print '<td colspan="5" align="center">';
        	print '<input type="button" name="save" class="button" value="'.$langs->trans("Valider la pice").'" onclick="document.getElementById(\'action_demandee\').value=\'controle_piece\';document.form_saisie.submit();">&nbsp;&nbsp;&nbsp;';
			print '<input type="button" name="cancel" class="button" value="'.$langs->trans("Cancel").'" onclick="document.getElementById(\'action_demandee\').value=\'annule_piece\';document.form_saisie.submit();">';
			print '</td></tr>';
        }
		print '</table></td></tr>';
	    print '<input type="hidden" name="nb_lignes" value="'.$nb_lignes.'">';
		print '<input type="hidden" name="nb_lignes_reglement" value="'.$nb_lignes_reglement.'">';
		print "</form>";

		print "<tr class=\"noborder\"><td colspan=\"8\">&nbsp;</td></tr>\n";
    
    }
	
	$sql = "SELECT p.rowid, p.date_piece as datep, p.montant, p.libelle, p.journal, p.num_piece, p.tiers, p.code_origine, p.reference, p.exportee, p.code_lettrage, p.type_piece, p.montant_ht, p.montant_tva";
    $sql .=", n.libelle as libelle_nature, s.nom as libelle_tiers";
	$sql .= " FROM ".MAIN_DB_PREFIX."compta_pieces as p";
	$sql .=" LEFT JOIN ".MAIN_DB_PREFIX."societe as s ON p.tiers = s.idp";
	$sql .= " LEFT JOIN ".MAIN_DB_PREFIX."compta_lignes as l ON l.id_piece=p.rowid";
	$sql .=" LEFT JOIN ".MAIN_DB_PREFIX."compta_natures as n ON l.nature = n.rowid ";
	$sql .= " WHERE l.num_ligne = 1 AND p.type_piece = '".$type_piece."'";
	
  //filtre de recherche
	_filtre_recherche($db);
	
	print "<tr class=\"noborder\"><td colspan=\"8\">";
	print_fiche_titre("Liste des ".$libelle_type_piece."s : ",_entete_pagination($db));
	print "</td></tr>\n";
	
        // Ligne de titre tableau des acritures
    print '<tr class="liste_titre">';
    print '<td>'.$langs->trans("Date").'</td><td>'.$langs->trans("Nature").'</td><td>'.$langs->trans("Libell").'</td><td>'.$langs->trans("Tiers").'</td><td>'.$langs->trans("Origine").'</td><td>'.$langs->trans("Rfrence").'</td>';
    print '<td colspan="2">'.$langs->trans("Montant").'</td>';
    print '</tr>';

	print '<form name="form_affich" method="post">';
	print '<input id="action_demandee" type="hidden" name="action_demandee" value="search">';
    print '<input type="hidden" name="type_piece" value="' . $type_piece . '">';
    print '<input type="hidden" id="page" name="page" value="' . $page . '">';
	print '<input type="hidden" name="vline" value="' . $vline . '">';
    print '<tr '.$bc[true].'>';
	print '<td>Chercher:</td>';
	print '<td><input type="text" class="flat" name="req_nature" value="'.$_POST["req_nature"].'" size="10"></td>';
	print '<td><input type="text" class="flat" name="req_libelle" value="'.$_POST["req_libelle"].'" size="20"></td>';
	print '<td><input type="text" class="flat" name="req_tiers" value="'.$_POST["req_tiers"].'" size="10"></td>';
	print '<td><input type="text" class="flat" name="req_origine" value="'.$_POST["req_origine"].'" size="6"></td>';
	print '<td><input type="text" class="flat" name="req_reference" value="'.$_POST["req_reference"].'" size="6"></td>';
	print '<td align="right"><input type="text" class="flat" name="req_montant" value="'.$_POST["req_montant"].'" size="5"></td>';
	print '<td align="center" width="40"><input type="image" class="liste_titre" src="'.DOL_URL_ROOT.'/theme/'.$conf->theme.'/img/search.png" alt="'.$langs->trans("Search").'"></td>';
	print "</tr>\n";
		
	// chargement des pieces  afficher
    $sql.= $sql_rech;
    $sql.= " ORDER BY p.datep ASC, n.libelle_nature ASC, s.libelle_tiers ASC";
    $sql.= $db->plimit($limitsql, 0);
	//print "<script language='javascript'>alert('".$sql."');</script>";
	//echo '<br>'.$sql.'<br>';
    
    $result = $db->query($sql);
    if ($result)
    {
       $total = _print_piece($db, $result, $sql);
       $db->free($result);
    }
 
    
    print "</form>\n";
	print "</table>";
	
 /*
     *  Boutons actions
     */
    if ($action_encours != 'saisir_piece' || $action_demandee == 'annule_piece')
    {
        print '<div class="tabsAction">';
        
        if ($user->rights->banque->modifier)
        {
            print "<a class=\"tabAction\" href=\"#\"  onclick=\"document.getElementById('action_demandee').value='nouvelle_piece';document.form_affich.submit();\">".$langs->trans("Saisir une ".strtolower($libelle_type_piece))."</a>";
        }
    
        print '</div>';
    }

    print '<br>';
   
$db->close();

llxFooter('$Date: 2005/10/15 16:01:56 $ - $Revision: 1.63 $');


/**
 *      \brief      Affiche ligne ecriture
 *      \param      db          Handler d'accs base
 *      \param      result      Resultset du select
 *      \param      sql         Requete sql
 *      \param      acct        Compte
 *      \return     Renvoi total solde
 */
function _print_piece($db,$result,$sql)
{
    global $langs, $bc, $nb_pieces, $viewline, $user, $page;
    
    $var=true;
    $total=0;
    
    $num = $db->num_rows($result);
    $i = 0; $total = 0; $sep = 0;
    
 //print "<script language='javascript'>alert('".$nb_pieces."');</script>";		
 //print "<script language='javascript'>alert('".$viewline."');</script>";		
    while ($i < $num)
    {
        $objp = $db->fetch_object($result);
        $time = time();
        if ($i >= ($nb_pieces - $viewline))
        {
            $var=!$var;
    
            print "<tr $bc[$var]>";
            print "<td nowrap>".dolibarr_print_date($objp->datep,"%d/%m/%y")."</td>\n";
            print "<td nowrap>&nbsp;".$objp->libelle_nature."</td>\n";
            print "<td nowrap>".$objp->libelle."</td>\n";
			print "<td nowrap>&nbsp;".$objp->libelle_tiers."</td>\n";
            print "<td nowrap>&nbsp;".$objp->code_origine."</td>\n";
            print "<td nowrap>&nbsp;".$objp->reference."</td>\n";
            
            print "<td align=\"right\" nowrap>&nbsp;".price($objp->montant)."</td>\n";
                
            if ($action_demandee =='search')
            {
                print '<td align="right">-</td>';
            }
    
            print "<td align=\"center\"><a href=\"#\" onclick=\"return affichage_lignes(".$objp->rowid.");\">Lignes</a></td>\n";
			print '</tr>';
    
            print '<tr><td colspan="8">';
			_charge_lignes($db, $objp->rowid);
			print "</td></tr>";
		}
    
        $i++;
    }

    return $total;
}

function _print_lignes($db,$result)
{
    global $langs, $bc, $nb_pieces, $viewline, $user, $page;
    
    $var=true;
    $total=0;
    
    $num = $db->num_rows($result);
    $i = 0; $total = 0; $sep = 0;
    
    while ($i < $num)
    {
        $objp = $db->fetch_object($result);
        $time = time();
		$compte = new Compte($db, $objp->compte);
        //if ($i >= ($nb_pieces - $viewline))
        //{
            $var=!$var;
    
            print "<tr $bc[yes]>";
            print '<td></td>';
			print "<td nowrap>&nbsp;".$objp->num_ligne."</td>\n";
            print '<td nowrap>&nbsp;'.$objp->libelle."</td>\n";
            print "<td nowrap>&nbsp;".$compte->getNumero()."</td>\n";
			print "<td nowrap>&nbsp;".$objp->sens."</td>\n";
            print "<td align=\"right\" nowrap>&nbsp;".price($objp->montant)."</td>\n";
            print "</tr>";
        //}
    
        $i++;
    }

    return $total;
}
// Chrargement lignes de la pice
function _charge_lignes($db, $id_piece) {
	global $langs;
	
	print '<div id="Lignes_'.$id_piece.'" style="display:none;">';
	print '<table class="notopnoleftnoright" width="100%">';
	print '<tr '.$bc[false].'>';
	print '<td></td>';
	print '<td>'.$langs->trans("Ligne").'</td><td>'.$langs->trans("Libell ligne").'</td><td>'.$langs->trans("Compte").'</td><td>'.$langs->trans("Sens").'</td><td align="right">'.$langs->trans("Montant").'</td>';
    print '</td></tr>';

	$sql = "SELECT * FROM ".MAIN_DB_PREFIX."compta_lignes as l WHERE l.id_piece = ".$id_piece." ORDER BY l.journal, l.num_piece, l.num_ligne";
	$result = $db->query($sql);
    if ($result)
    {
        $total = _print_lignes($db, $result);
        $db->free($result);
    }
	print "</table>";
	print "</div>";	
}

// Chargement des journaux dans $journaux
function _charge_journaux($db)
 {
	$sql = "SELECT code_journal, libelle FROM ".MAIN_DB_PREFIX."compta_journaux ORDER BY code_journal;";
	$result = $db->query($sql);
	if ($result)
    {
        $num = $db->num_rows($result);
        $i = 1;
        $journaux = "<option value=\"0\"";
		if (!$_POST["journal"]) {
			$journaux .= " selected=\"true\"";
			$journal_sel = "";
		}
		else {
			$journal_sel = $_POST["journal"];
		}
		$journaux .= ">&nbsp;</option>";
        while ($i <= $num)
        {
            $obj = $db->fetch_object($result);
            $journaux .= "<option value=\"$obj->code_journal\"";
			if ($obj->code_journal == $journal_sel) $journaux .= " selected=\"true\"";
			$journaux .= ">$obj->code_journal - $obj->libelle</option>\n";
            $i++;
        }
        $db->free($result);
		return $journaux;
	}
}
// Chargement des tiers dans $liste_tiers
function _charge_tiers($db)
 {
	global $type_piece;

 	$sql = "SELECT idp, nom FROM ".MAIN_DB_PREFIX."societe";
	if ($type_piece == 'DEP') $sql.=" WHERE fournisseur = '1'";
	elseif ($type_piece == 'REC') $sql.=" WHERE fournisseur = '0'";
	$sql .= " ORDER BY nom;";
	
	$result = $db->query($sql);
	if ($result)
    {
        $num = $db->num_rows($result);
        $i = 1;
        $liste_tiers = "<option value=\"0\"";
		if (!$_POST["tiers"]) {
			$liste_tiers .= " selected=\"true\"";
			$tiers_sel = "0";
		}
		else {
			$tiers_sel = $_POST["tiers"];
		}
		$liste_tiers .= ">&nbsp;</option>";
        while ($i <= $num)
        {
            $obj = $db->fetch_object($result);
            $liste_tiers .= "<option value=\"$obj->idp\"";
			if ($obj->idp == $tiers_sel) $liste_tiers .= " selected=\"true\"";
			$liste_tiers .= ">$obj->nom</option>\n";
            $i++;
        }
        $db->free($result);
		return $liste_tiers;
	}
}
// Chargement des natures
function _charge_mrg($db) 
{
	$sql = "SELECT libelle, id from ".MAIN_DB_PREFIX."c_paiement WHERE type='2' and active='1' ORDER BY libelle";
	$result = $db->query($sql);
	if ($result)
    {
        $num = $db->num_rows($result);
        $i = 1;
        $liste_mrg = "<option value=\"0\"";
		if (!$_POST["mrg"]) {
			$liste_mrg .= " selected=\"true\"";
			$mrg_sel = "";
		}
		else {
			$mrg_sel = $_POST["mrg"];
		}
		$liste_mrg .= ">&nbsp;</option>";
        while ($i <= $num)
        {
            $obj = $db->fetch_object($result);
            $liste_mrg .= "<option value=\"$obj->id\"";
			if ($obj->id == $mrg_sel) $liste_mrg .= " selected=\"true\"";
			$liste_mrg .= ">$obj->libelle</option>\n";
            $i++;
        }
        $db->free($result);
		return $liste_mrg;
	}
}
// Chargement des natures
function _charge_tresos($db)
{
	$sql = "SELECT label, rowid from ".MAIN_DB_PREFIX."bank_account ORDER BY account_number";
	$result = $db->query($sql);
	if ($result)
    {
        $num = $db->num_rows($result);
        $i = 1;
        $liste_tresos = "<option value=\"0\"";
		if (!$_POST["treso"]) {
			$liste_tresos .= " selected=\"true\"";
			$treso_sel = "";
		}
		else {
			$treso_sel = $_POST["treso"];
		}
		$liste_tresos .= ">&nbsp;</option>";
        while ($i <= $num)
        {
            $obj = $db->fetch_object($result);
            $liste_tresos .= "<option value=\"$obj->rowid\"";
			if ($obj->rowid == $treso_sel) $liste_tresos .= " selected=\"true\"";
			$liste_tresos .= ">$obj->label</option>\n";
            $i++;
        }
        $db->free($result);
		return $liste_tresos;
	}
}
// Chargement des natures
function _charge_natures($db)
 {
	global $type_piece;
	$sql = "SELECT rowid, libelle FROM ".MAIN_DB_PREFIX."compta_natures WHERE type_nature = '";
	$sql .= $type_piece;
	$sql .= "' ORDER BY libelle ASC";
	$result = $db->query($sql);
	if ($result)
    {
        $num = $db->num_rows($result);
        $i = 1;
        $liste_natures = "<option value=\"0\"";
		if (!$_POST["nature"]) {
			$liste_natures .= " selected=\"true\"";
			$nature_sel = "";
		}
		else {
			$nature_sel = $_POST["nature"];
		}
		$liste_natures .= ">&nbsp;</option>";
        while ($i <= $num)
        {
            $obj = $db->fetch_object($result);
            $liste_natures .= "<option value=\"$obj->rowid\"";
			if ($obj->rowid == $nature_sel) $liste_natures .= " selected=\"true\"";
			$liste_natures .= ">$obj->libelle</option>\n";
            $i++;
        }
        $db->free($result);
		return $liste_natures;
	}
}

// Chargement des comptes dans $comptes_generaux
function _charge_comptes($db, $compte_ligne)
 {
	$sql = "SELECT rowid, numero, intitule FROM ".MAIN_DB_PREFIX."compta_compte_generaux";
	$sql.+ " ORDER BY numero;";
	$result = $db->query($sql);
	if ($result)
    {
        $num = $db->num_rows($result);
        $i = 1;
        $comptes_generaux = "<option value=\"0\"";
		if ($compte_ligne == '0') {
			$comptes_generaux .= " selected=\"true\"";
			$compte_sel = "";
		}
		else {
			$compte_sel = $compte_ligne;
		}
		$comptes_generaux .= ">&nbsp;</option>";
        while ($i <= $num)
        {
            $obj = $db->fetch_object($result);
            $comptes_generaux .= "<option value=\"$obj->rowid\"";
			if ($obj->rowid == $compte_sel) $comptes_generaux .= " selected=\"true\"";
			$comptes_generaux .= ">$obj->numero - $obj->intitule</option>\n";
            $i++;
        }
        $db->free($result);
	}
	return $comptes_generaux;
}

// affichage d'une ligne
function _affiche_ligne($db, $i, $sens_prec, $num_ligne) {
	global $nb_lignes, $libelle_ligne, $compte_ligne, $sens_ligne, $montant_ligne, $action_demandee;
	
	//print "<script language='javascript'>alert('".$montant_ligne[($i - 1)]."');</script>";		

	if (!$_POST["montant_ligne_".$i] || $action_demandee == 'generer_lignes') 
	{
		$compte = $compte_ligne[($i - 1)];
		$libelle = $libelle_ligne[($i - 1)];
		$sens = $sens_ligne[($i - 1)];
		$montant = $montant_ligne[($i - 1)];
	}
	else
	{
		$compte = isset($_POST["compte_ligne_".$i])?$_POST["compte_ligne_".$i]:'0';
		$libelle = $_POST["libelle_ligne_".$i];
		$sens = $_POST["sens_ligne_".$i];
		$montant = $_POST["montant_ligne_".$i];	
	}
	print '<tr '.$bc[true].'>';
	print '<td align="right">'.$num_ligne.'</td>';
	print '<td><input name="libelle_ligne_'.$num_ligne.'" class="flat" type="text" size="50" value="'.$libelle.'"></td>';
	print '<td><select class="flat" name="compte_ligne_'.$num_ligne.'">'._charge_comptes($db, $compte).'</select></td>';
	print '<td><select name="sens_ligne_'.$num_ligne.'" class="flat">';
	print '<option value="D"';
	if ($sens == 'D') {
		$new_sens = 'D';
		print " selected";
	}
	elseif ($sens_prec == 'C' && $sens != 'C') {
		$new_sens = 'D';
		print " selected";
	}
	print '>Dbit</option>';
	print '<option value="C"';
	if ($sens == 'C') {
		$new_sens = 'C';
		print " selected";
	}
	elseif ($sens_prec == 'D' && $sens != 'D') {
		$new_sens = 'C';
		print " selected";
	}
	print '>Crdit</option>';
	print '</select>';
	print '</td>';
	print '<td><input name="montant_ligne_'.$num_ligne.'" class="flat" type="text" size="6" value="'.$montant.'"></td>';
	print '<td align="center">';
	print '<a href="#" onclick="document.getElementById(\'action_demandee\').value=\'del_ligne\';document.getElementById(\'ligne_del\').value='.$num_ligne.';document.form_saisie.submit();">';
	print img_delete();
	print '</a></td>';
	print '</tr>';
	return $new_sens;
}

// affichage d'une ligne
function _affiche_ligne_reglement($db, $i, $sens_prec, $num_ligne_reglement) {
	global $nb_lignes_reglement, $libelle_ligne_reglement, $compte_ligne_reglement, $sens_ligne_reglement, $montant_ligne_reglement, $action_demandee;
	
	//print "<script language='javascript'>alert('".$montant_ligne[($i - 1)]."');</script>";		

	if (!$_POST["montant_ligne_reglement_".$i] || $action_demandee == 'generer_lignes_reglement') 
	{
		$compte = $compte_ligne_reglement[($i - 1)];
		$libelle = $libelle_ligne_reglement[($i - 1)];
		$sens = $sens_ligne_reglement[($i - 1)];
		$montant = $montant_ligne_reglement[($i - 1)];
	}
	else
	{
		$compte = isset($_POST["compte_ligne_reglement_".$i])?$_POST["compte_ligne_reglement_".$i]:'0';
		$libelle = $_POST["libelle_ligne_reglement_".$i];
		$sens = $_POST["sens_ligne_reglement_".$i];
		$montant = $_POST["montant_ligne_reglement_".$i];	
	}
	print '<tr '.$bc[true].'>';
	print '<td align="right">'.$num_ligne_reglement.'</td>';
	print '<td><input name="libelle_ligne_reglement_'.$num_ligne_reglement.'" class="flat" type="text" size="50" value="'.$libelle.'"></td>';
	print '<td><select class="flat" name="compte_ligne_reglement_'.$num_ligne_reglement.'">'._charge_comptes($db, $compte).'</select></td>';
	print '<td><select name="sens_ligne_reglement_'.$num_ligne_reglement.'" class="flat">';
	print '<option value="D"';
	if ($sens == 'D') {
		$new_sens = 'D';
		print " selected";
	}
	elseif ($sens_prec == 'C' && $sens != 'C') {
		$new_sens = 'D';
		print " selected";
	}
	print '>Dbit</option>';
	print '<option value="C"';
	if ($sens == 'C') {
		$new_sens = 'C';
		print " selected";
	}
	elseif ($sens_prec == 'D' && $sens != 'D') {
		$new_sens = 'C';
		print " selected";
	}
	print '>Crdit</option>';
	print '</select>';
	print '</td>';
	print '<td><input name="montant_ligne_reglement_'.$num_ligne_reglement.'" class="flat" type="text" size="6" value="'.$montant.'"></td>';
	print '<td align="center">';
	print '<a href="#" onclick="document.getElementById(\'action_demandee\').value=\'del_ligne_reglement\';document.getElementById(\'ligne_del_reglement\').value='.$num_ligne_reglement.';document.form_saisie.submit();">';
	print img_delete();
	print '</a></td>';
	print '</tr>';
	return $new_sens;
}

// validation d'une piece
function _valid_piece($db)
{
	global $user, $type_piece, $nb_lignes, $libelle_ligne, $compte_ligne, $sens_ligne, $montant_ligne;
	
	$date_piece = strftime( "%Y-%m-%d", mktime(0, 0, 0, substr($_POST["datep"],3,2), substr($_POST["datep"],0,2), substr($_POST["datep"],6)));
	$nature=$_POST["nature"];
    $libelle=$_POST["libelle"];
    $montant_ht=str_replace(',','.',$_POST["montant_ht"]);
    $montant_tva=str_replace(',','.',$_POST["montant_tva"]);
    $montant_ttc=str_replace(',','.',$_POST["montant_ttc"]);
 	if ($montant_ttc == '') $montant_ttc = $montant_ht + $montant_tva;
	elseif ($montant_ht == '') $montant_ht = $montant_ttc - $montant_tva;
	elseif ($montant_tva == '') $montant_tva = $montant_ttc - $montant_ht;
    $tiers=$_POST["tiers"];
	$reference=$_POST["reference"];
	$mrg=$_POST["mrg"];
	$code_origine=$user->login;
	
	$tp = new Type_Piece($db, $type_piece);
	$journal = $tp->getJournal();
	
    $db->begin();
	$piece=new Piece($db);
	$id_piece = $piece->nouvelle_piece($journal, $date_piece, $montant_ttc, $libelle, $tiers, $code_origine, $reference, $type_piece, $montant_ht, $montant_tva, $mrg);
	
    if ($id_piece)
    {
		$num_piece = $piece->getNumPiece();
		$i = 1;
		$err = 0;
		while ($i <= sizeOf($compte_ligne)) 
		{
			if (!$_POST["montant_ligne_".$i]) 
			{
				$compte_l = $compte_ligne[($i - 1)];
				$libelle_l = $libelle_ligne[($i - 1)];
				$sens_l = $sens_ligne[($i - 1)];
				$montant_l = $montant_ligne[($i - 1)];
			}
			else
			{
				$compte_l = isset($_POST["compte_ligne_".$i])?$_POST["compte_ligne_".$i]:'0';
				$libelle_l = $_POST["libelle_ligne_".$i];
				$sens_l = $_POST["sens_ligne_".$i];
				$montant_l = $_POST["montant_ligne_".$i];
			}
			if ($libelle_l == '') $libelle_l = $libelle;
			$ligne = new Ligne($db);
			$id_ligne = $ligne->nouvelle_ligne($id_piece, $i, $journal, $num_piece, $nature, $compte_l, str_replace(',','.',$montant_l), $sens_l, $libelle_l);
			if (!$id_ligne) $err = 1;
			$i++;
		}
		if ($err == 0) $db->commit();
		else $db->rollback();
		
		return $id_piece;
		//Header("Location: deprec.php?type_piece=".$type_piece);
    }
    else
    {
		$db->rollback();
        dolibarr_print_error($db);
    }
}

// validation d'une piece
function _valid_piece_reglement($db)
{
	global $user, $type_piece, $type_piece_reglement, $nb_lignes_reglement, $libelle_ligne_reglement, $compte_ligne_reglement, $sens_ligne_reglement, $montant_ligne_reglement;
	
	$date_piece = strftime( "%Y-%m-%d", mktime(0, 0, 0, substr($_POST["datep"],3,2), substr($_POST["datep"],0,2), substr($_POST["datep"],6)));
	$nature=$_POST["nature"];
    $libelle=$_POST["libelle"];
    $montant_ht=str_replace(',','.',$_POST["montant_ht"]);
    $montant_tva=str_replace(',','.',$_POST["montant_tva"]);
    $montant_ttc=str_replace(',','.',$_POST["montant_ttc"]);
	if ($montant_ttc == '') $montant_ttc = $montant_ht + $montant_tva;
	elseif ($montant_ht == '') $montant_ht = $montant_ttc - $montant_tva;
	elseif ($montant_tva == '') $montant_tva = $montant_ttc - $montant_ht;
    $tiers=$_POST["tiers"];
	$reference=$_POST["reference"];
	$mrg=$_POST["mrg"];
	$code_origine=$user->login;
	
	
	$param = new Param($db);
	if ($type_piece == $param->getValeur("TYPE_PIECE_DEPENSE")) $type_piece_reglement = $param->getValeur("TYPE_PIECE_PAIEMENT_FOURNISSEUR");
	elseif ($type_piece == $param->getValeur("TYPE_PIECE_RECETTE")) $type_piece_reglement = $param->getValeur("TYPE_PIECE_REGLEMENT_CLIENT");
	$tp = new Type_Piece($db, $type_piece_reglement);
	$journal = $tp->getJournal();
	
    $db->begin();
	$piece=new Piece($db);
	$id_piece = $piece->nouvelle_piece($journal, $date_piece, $montant_ttc, $libelle, $tiers, $code_origine, $reference, $type_piece, $montant_ht, $montant_tva, $mrg);
	
    if ($id_piece)
    {
		$num_piece = $piece->getNumPiece();
		$i = 1;
		$err = 0;
		while ($i <= sizeOf($compte_ligne_reglement)) 
		{
			if (!$_POST["montant_ligne_".$i]) 
			{
				$compte_l = $compte_ligne_reglement[($i - 1)];
				$libelle_l = $libelle_ligne_reglement[($i - 1)];
				$sens_l = $sens_ligne_reglement[($i - 1)];
				$montant_l = $montant_ligne_reglement[($i - 1)];
			}
			else
			{
				$compte_l = isset($_POST["compte_ligne_reglement_".$i])?$_POST["compte_ligne_reglement_".$i]:'0';
				$libelle_l = $_POST["libelle_ligne_reglement_".$i];
				$sens_l = $_POST["sens_ligne_reglement_".$i];
				$montant_l = $_POST["montant_ligne_reglement_".$i];
			}
			if ($libelle_l == '') $libelle_l = $libelle;
			$ligne = new Ligne($db);
			$id_ligne = $ligne->nouvelle_ligne($id_piece, $i, $journal, $num_piece, $nature, $compte_l, str_replace(',','.',$montant_l), $sens_l, $libelle_l);
			if (!$id_ligne) $err = 1;
			$i++;
		}
		if ($err == 0) $db->commit();
		else $db->rollback();
		
		return $id_piece;
		//Header("Location: deprec.php?type_piece=".$type_piece);
    }
    else
    {
		$db->rollback();
        dolibarr_print_error($db);
    }
}

// Controle saisie
function _controle_piece($db) {
    global $type_piece, $nb_lignes, $libelle_ligne, $compte_ligne, $sens_ligne, $montant_ligne, $montant_ttc, $montant_ht, $montant_tva;
	global $type_piece_reglement, $nb_lignes_reglement, $libelle_ligne_reglement, $compte_ligne_reglement, $sens_ligne_reglement, $montant_ligne_reglement;
	
	$date_piece = strftime( "%Y-%m-%d", mktime(0, 0, 0, substr($_POST["datep"],3,2), substr($_POST["datep"],0,2), substr($_POST["datep"],6)));
    $nature=$_POST["nature"];
    $libelle=$_POST["libelle"];
    $montant_ht=str_replace(',','.',$_POST["montant_ht"]);
    $montant_tva=str_replace(',','.',$_POST["montant_tva"]);
    $montant_ttc=str_replace(',','.',$_POST["montant_ttc"]);
    $tiers=$_POST["tiers"];
	$mrg=$_POST["mrg"];
	$treso=$_POST["treso"];
	$montant_reglement=str_replace(',','.',$_POST["montant_reglement"]);
	$erreur = 0;

	if (!checkdate((int)substr($_POST["datep"],3,2), (int)substr($_POST["datep"],0,2), (int)substr($_POST["datep"],6)))
	{
		$erreurs[$erreur] = "Date invalide";
		$erreur++;
	}
	if ($nature == 0) 
	{
		$erreurs[$erreur] = "Nature non renseigne";
		$erreur++;
	}
	
	if ($tiers == 0) 
	{
		$erreurs[$erreur] = "Tiers non renseign";
		$erreur++;
	}
	if ($montant_ttc == '' && $montant_ht == '') 
	{
		$erreurs[$erreur] = "Montant non renseign";
		$erreur++;
	}
	elseif ($montant_ttc == '') $montant_ttc = $montant_ht + $montant_tva;
	elseif ($montant_ht == '') $montant_ht = $montant_ttc - $montant_tva;
	elseif ($montant_tva == '') $montant_tva = $montant_ttc - $montant_ht;
	
	if ($nb_lignes == 0) $nb_lignes_ctl = _genere_lignes($db, $tiers, $nature, $libelle, $montant_ht, $montant_tva, $montant_ttc, $tiers, $mrg, $treso, $montant_reglement);
	else $nb_lignes_ctl = $nb_lignes;
	
	$i = 1;
	$total_debit = 0;
	$total_credit = 0;
	while ($i <= $nb_lignes_ctl) {
		if (!$_POST["montant_ligne_".$i])
		{
			$compte_l = $compte_ligne[($i - 1)];
			$libelle_l = $libelle_ligne[($i - 1)];
			$sens_l = $sens_ligne[($i - 1)];
			$montant_l = str_replace(',','.',$montant_ligne[($i - 1)]);
		}
		else
		{
			$compte_ligne[($i - 1)] = $compte_l = isset($_POST["compte_ligne_".$i])?$_POST["compte_ligne_".$i]:'0';
			$libelle_ligne[($i - 1)] = $libelle_l = $_POST["libelle_ligne_".$i];
			$sens_ligne[($i - 1)] = $sens_l = $_POST["sens_ligne_".$i];
			$montant_ligne[($i - 1)] = $montant_l = str_replace(',','.',$_POST["montant_ligne_".$i]);
		}
		if ($compte_l == '0') {
		$erreurs[$erreur] = "Compte ligne ".$i." non renseign";
		$erreur++;
		}
		if ($montant_l == '0') {
			$erreurs[$erreur] = "Montant ligne ".$i." non renseign";
			$erreur++;
		}
		else {
			if ($sens_l == 'D') $total_debit += $montant_l;
			else $total_credit += $montant_l;
		}
		$i++;
	}
	$equilibre = $total_debit - $total_credit;
	if (round($equilibre, 2) != 0) {
		$erreurs[$erreur] = "Erreur d'quilibrage (".$equilibre."): le total des dbits (".$total_debit.") est diffrent du total des crdits (".$total_credit.")";
		$erreur++;
	}
	if ($total_debit == 0) {
		$erreurs[$erreur] = "Saisissez les lignes de l'criture";
		print '<script language="javascript">affichage_ligne_saisie("yes");</script>';
		$erreur++;
	}
	if ($nb_lignes_reglement == 0) $nb_lignes_ctl = _genere_lignes_reglement($db, $tiers, $nature, $libelle, $montant_ht, $montant_tva, $montant_ttc, $tiers, $mrg, $treso, $montant_reglement);
	else $nb_lignes_ctl = $nb_lignes_reglement;
	
	$i = 1;
	$total_debit = 0;
	$total_credit = 0;
	while ($i <= $nb_lignes_ctl) {
		if (!$_POST["montant_ligne_reglement_".$i])
		{
			$compte_l = $compte_ligne_reglement[($i - 1)];
			$libelle_l = $libelle_ligne_reglement[($i - 1)];
			$sens_l = $sens_ligne_reglement[($i - 1)];
			$montant_l = str_replace(',','.',$montant_ligne_reglement[($i - 1)]);
		}
		else
		{
			$compte_ligne_reglement[($i - 1)] = $compte_l = isset($_POST["compte_ligne_reglement_".$i])?$_POST["compte_ligne_reglement_".$i]:'0';
			$libelle_ligne_reglement[($i - 1)] = $libelle_l = $_POST["libelle_ligne_reglement_".$i];
			$sens_ligne_reglement[($i - 1)] = $sens_l = $_POST["sens_ligne_reglement_".$i];
			$montant_ligne_reglement[($i - 1)] = $montant_l = str_replace(',','.',$_POST["montant_ligne_reglement_".$i]);
		}
		if ($compte_l == '0') {
		$erreurs[$erreur] = "Compte ligne reglement ".$i." non renseign";
		$erreur++;
		}
		if ($montant_l == '0') {
			$erreurs[$erreur] = "Montant ligne reglement ".$i." non renseign";
			$erreur++;
		}
		else {
			if ($sens_l == 'D') $total_debit += $montant_l;
			else $total_credit += $montant_l;
		}
		$i++;
	}
	$equilibre = $total_debit - $total_credit;
	if (round($equilibre, 2) != 0) {
		$erreurs[$erreur] = "Erreur d'quilibrage reglement : le total des dbits (".$total_debit.") est diffrent du total des crdits (".$total_credit.")";
		$erreur++;
	}
	return $erreurs;
}

function _filtre_recherche($db) 
{
   global $langs, $bc, $limit, $total_pieces, $nb_pieces, $viewline, $user, $page, $limitsql, $sql_rech, $nb_lignes, $nb_lignes_reglement, $nb_erreurs, $action_encours, $type_piece;

    $sql = "SELECT count(*) as nb";
    $sql .= " FROM ".MAIN_DB_PREFIX."compta_pieces as p";
	$sql .=" LEFT JOIN ".MAIN_DB_PREFIX."societe as s ON p.tiers = s.idp";
	$sql .= " LEFT JOIN ".MAIN_DB_PREFIX."compta_lignes as l ON l.id_piece=p.rowid";
	$sql .=" LEFT JOIN ".MAIN_DB_PREFIX."compta_natures as n ON l.nature = n.rowid ";
	$sql .= " WHERE l.num_ligne = 1 AND p.type_piece = '".$type_piece."'";
	  
  $sql_rech="";
  $mode_search = 0;
  
  if ($_POST["req_nature"]) 
    { 
      $sql_rech .= " AND n.libelle like '".strtolower($_POST["req_nature"])."%'";
      $mode_search = 1;
    }
  if ($_POST["req_tiers"]) 
    { 
      $sql_rech .= " AND s.nom like '".strtolower($_POST["req_tiers"])."%'";
      $mode_search = 1;
    }
  if ($_POST["req_libelle"]) 
    { 
      $sql_rech .= " AND";
	  $sql_rech .= " p.libelle like '".strtolower($_POST["req_libelle"])."%'";
      $mode_search = 1;
    }
  if ($_POST["req_origine"]) 
    { 
      $sql_rech .= " AND";
	  $sql_rech .= " p.code_origine like '".strtolower($_POST["req_origine"])."%'";
      $mode_search = 1;
    }
  if ($_POST["req_reference"]) 
    { 
      $sql_rech .= " AND";
	  $sql_rech .= " p.reference like '".strtolower($_POST["req_reference"])."%'";
      $mode_search = 1;
    }
  if ($_POST["req_montant"]) 
    { 
      $sql_rech .= " AND";
	  $sql_rech .= " p.montant = '".$_POST["req_montant"]."'";
      $mode_search = 1;
    }

  $sql .= $sql_rech;
  $result=$db->query($sql);
  if ($result)
    {
      $obj = $db->fetch_object($result);
      $nb_pieces = $obj->nb;
      $total_pieces = $nb_pieces;
	  $db->free($result);
    }
    else {
        dolibarr_print_error($db);
    }

  $viewline = 24;
  if ($action_encours == 'saisir_piece') $viewline = $viewline - 7;
  if ($nb_erreurs > 0) $viewline = $viewline - $nb_erreurs;
  if ($nb_lignes > 0) $viewline = $viewline - ($nb_lignes + 2);
  if ($ligne_del > 0) $viewline--;

  if ($nb_lignes_reglement > 0) $viewline = $viewline - ($nb_lignes_reglement + 2);
  if ($ligne_del_reglement > 0) $viewline--;
  
  if ($page > 0 && $mode_search == 0)
    {
      $limitsql = $nb_pieces - ($page * $viewline);
      if ($limitsql < $viewline)
		{
		  $limitsql = $viewline;
		}
      $nb_pieces = $limitsql;
    }
  else
    {
      $page = 0;
      $limitsql = $nb_pieces;
    }
}	

function _entete_pagination($db) 
{
   global $langs, $bc, $limit, $total_pieces, $nb_pieces, $viewline, $user, $page, $limitsql, $sql_rech, $nb_lignes, $nb_lignes_reglement, $nb_erreurs, $action_encours;

   $mesg='';
   $nbpage=floor($total_pieces/$viewline)+($total_pieces % $viewline > 0?1:0);  // Nombre de page total

   if ($limitsql > $viewline)
   {
        $mesg.='<a href="#"  onclick="document.getElementById(\'page\').value=\'';
		$mesg.=$page+1;
		$mesg.='\';';
		if ($action_encours == 'saisir_piece') $mesg .= 'document.form_saisie.submit();';
		else $mesg .= 'document.form_affich.submit();';
		$mesg.='">'.img_previous().'</a>';
   }
    $mesg.= ' Page '.($nbpage-$page).'/'.$nbpage.' ';
   if ($total_pieces > $limitsql )
   {
        $mesg.= '<a href="#"  onclick="document.getElementById(\'page\').value=\'';
		$mesg.= $page-1;
		$mesg.='\';';
		if ($action_encours == 'saisir_piece') $mesg .= 'document.form_saisie.submit();';
		else $mesg .= 'document.form_affich.submit();';
		$mesg.='">'.img_next().'</a>';
   }
	return $mesg;
}


function _genere_lignes($db, $tiers, $nature, $libelle, $montant_ht, $montant_tva, $montant_ttc, $tiers, $mrg, $treso, $montant_reglement)
{
  global $nb_lignes, $libelle_ligne, $compte_ligne, $sens_ligne, $montant_ligne;
  
  $sql = "select code_compta from ".MAIN_DB_PREFIX."societe where idp='".$tiers."'";
  $result=$db->query($sql);
  if ($result)
    {
      $obj = $db->fetch_object($result);
 	  $compte_tiers = $obj->code_compta;
	  $db->free($result);
    }

	$sql = "select rowid, type_nature, libelle, id_compte_associe from ".MAIN_DB_PREFIX."compta_natures where rowid='".$nature."'";
  $result=$db->query($sql);
  if ($result)
    {
      $obj = $db->fetch_object($result);
      $libelle_nature = $obj->libelle;
      $compte_nature = $obj->id_compte_associe;
	  $type_nature = $obj->type_nature;
	  $db->free($result);
    }
  
  if ($type_nature == _get_param($db, "TYPE_PIECE_DEPENSE"))
  {
	$sens_nature = 'D';
	$sens_tva = 'D';
	$sens_tiers = 'C';
	$compte_tva = _get_param($db, "COMPTE_TVA_DEDUCTIBLE");
  }
  elseif ($type_nature == _get_param($db, "TYPE_PIECE_RECETTE"))
  {
	$sens_nature = 'C';
	$sens_tva = 'C';
	$sens_tiers = 'D';
	$compte_tva = _get_param($db, "COMPTE_TVA_COLLECTEE");
  }
  
  $nb_lig_gen = 0;
  $libelle_ligne[$nb_lig_gen] = $libelle;
  $compte_ligne[$nb_lig_gen] = $compte_tiers;
  $sens_ligne[$nb_lig_gen]    = $sens_tiers;
  $montant_ligne[$nb_lig_gen] = $montant_ttc;
  
  $nb_lig_gen++;
  $libelle_ligne[$nb_lig_gen]= $libelle;
  $compte_ligne[$nb_lig_gen]  = $compte_nature;
  $sens_ligne[$nb_lig_gen]    = $sens_nature;
  $montant_ligne[$nb_lig_gen] = $montant_ht;
  
  if ($montant_tva != '') {
	  $nb_lig_gen++;
	  $libelle_ligne[$nb_lig_gen] = $libelle;
	  $compte_ligne[$nb_lig_gen]  = $compte_tva;
	  $sens_ligne[$nb_lig_gen]    = $sens_tva;
	  $montant_ligne[$nb_lig_gen] = $montant_tva;
  }
     
  $nb_lig_gen++;
  return $nb_lig_gen;
}

function _genere_lignes_reglement($db, $tiers, $nature, $libelle, $montant_ht, $montant_tva, $montant_ttc, $tiers, $mrg, $treso, $montant_reglement)
{
  global $nb_lignes_reglement, $libelle_ligne_reglement, $compte_ligne_reglement, $sens_ligne_reglement, $montant_ligne_reglement;
  
 $sql = "select code_compta from ".MAIN_DB_PREFIX."societe where idp='".$tiers."'";
  $result=$db->query($sql);
  if ($result)
    {
      $obj = $db->fetch_object($result);
 	  $compte_tiers = $obj->code_compta;
	  $db->free($result);
    }

	$sql = "select rowid, type_nature, libelle, id_compte_associe from ".MAIN_DB_PREFIX."compta_natures where rowid='".$nature."'";
  $result=$db->query($sql);
  if ($result)
    {
      $obj = $db->fetch_object($result);
      $libelle_nature = $obj->libelle;
      $compte_nature = $obj->id_compte_associe;
	  $type_nature = $obj->type_nature;
	  $db->free($result);
    }
  
  if ($type_nature == _get_param($db, "TYPE_PIECE_DEPENSE"))
  {
	$sens_tiers_2 = 'D';
	$sens_banque = 'C';
  }
  elseif ($type_nature == _get_param($db, "TYPE_PIECE_RECETTE"))
  {
	$sens_tiers_2 = 'C';
	$sens_banque = 'D';
  }
  else
  {
  	$sens_tiers_2 = 'D';
	$sens_banque = 'C';
	$compte_tiers = 0;
}
  
  if ($treso != '0')
  {
	$bank=new Account($db, $treso);
	$bank->fetch($treso);
	$compte_treso = $bank->compte;
  }
  
  $nb_lig_gen=0;
      
  if ($montant_reglement != '') {
	  $libelle_ligne_reglement[$nb_lig_gen] = $libelle;
	  $compte_ligne_reglement[$nb_lig_gen]  = $compte_treso;
	  $sens_ligne_reglement[$nb_lig_gen]    = $sens_banque;
	  $montant_ligne_reglement[$nb_lig_gen] = $montant_reglement;
	   
	  $nb_lig_gen++;
	  $libelle_ligne_reglement[$nb_lig_gen]= $libelle;
	  $compte_ligne_reglement[$nb_lig_gen]  = $compte_tiers;
	  $sens_ligne_reglement[$nb_lig_gen]    = $sens_tiers_2;
	  $montant_ligne_reglement[$nb_lig_gen] = $montant_reglement;
	  $nb_lig_gen++;
  }   
  return $nb_lig_gen;
}

function _get_param($db, $type) {
	$sql = "SELECT valeur FROM ".MAIN_DB_PREFIX."compta_param WHERE cle='$type'";
	$result = $db->query($sql);
	$obj = $db->fetch_object($result);
	return $obj->valeur;
}

function _get_libelle_nature($db, $id) {
	$sql = "SELECT libelle FROM ".MAIN_DB_PREFIX."compta_natures WHERE rowid='$id'";
	$result = $db->query($sql);
	$obj = $db->fetch_object($result);
	return $obj->libelle;
}
function _get_libelle_tiers($db, $id) {
	$sql = "SELECT nom FROM ".MAIN_DB_PREFIX."societe WHERE idp='$id'";
	$result = $db->query($sql);
	$obj = $db->fetch_object($result);
	return $obj->nom;
}
function _get_libelle_type_piece($db, $id) {
	$sql = "SELECT libelle FROM ".MAIN_DB_PREFIX."compta_type_piece WHERE rowid='$id'";
	$result = $db->query($sql);
	$obj = $db->fetch_object($result);
	return $obj->libelle;
}
?>
<script language="javascript">
// Affichage des lignes de la pice
function affichage_lignes(id_piece) {
	if (document.getElementById('Lignes_' + id_piece).style.display == 'inline') document.getElementById('Lignes_' + id_piece).style.display = 'none';
	else document.getElementById('Lignes_' + id_piece).style.display = 'inline';
	return false;
}
</script>